'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.check = check;
exports.remove = remove;
var TASK = exports.TASK = Symbol('TASK');
var kTrue = exports.kTrue = function kTrue() {
  return true;
};
var noop = exports.noop = function noop() {};

function check(value, predicate, error) {
  if (!predicate(value)) throw new Error(error);
}

var is = exports.is = {
  undef: function undef(v) {
    return v === null || v === undefined;
  },
  func: function func(f) {
    return typeof f === 'function';
  },
  array: Array.isArray,
  promise: function promise(p) {
    return p && typeof p.then === 'function';
  },
  generator: function generator(g) {
    return is.func(g) && g.constructor.name === 'GeneratorFunction';
  },
  iterator: function iterator(it) {
    return it && typeof it.next === 'function';
  },
  throw: function _throw(it) {
    return it && typeof it.throw === 'function';
  }
};

function remove(array, item) {
  var index = array.indexOf(item);
  if (index >= 0) array.splice(index, 1);
}